//===================================================================
//	pas1000s.c
//
//	Copyright (C) P&A Technologies Inc.
//===================================================================
#define	STRICT

#include <windows.h>
#include <tchar.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "pas1000w.h"

//-------------------------------------------------------------------
// 萔
//-------------------------------------------------------------------
// \
#define DATA_RESOLUTION		65536
// ^Cg
static const TCHAR szTitle[] = _T( "PA-S1000 Sample" );
// USB][h
static LPCTSTR STR_USB_MODE[] = { _T( "FULL SPEED" ), _T( "HI SPEED" ) };
// j
static LPCTSTR STR_WEEK[] = { _T( "" ), _T( "" ), _T( "" ), _T( "" ), _T( "" ), _T( "" ), _T( "y" ) };
// 샂[h
static LPCTSTR STR_ENABLE[] = { _T( "" ), _T( "L" ) };
static LPCTSTR STR_ANALOG_TYPE[] = { _T( "d" ), _T( "" ), _T( "" ), _T( "" ), _T( "" ), _T( "" ), _T( "" ), _T( "" ), _T( "" ), _T( "R" ) };
static LPCTSTR STR_ANALOG_RANGE[] = { _T( "}100mV" ), _T( "}200mV" ), _T( "}500mV" ), _T( "}1V" ), _T( "}2V" ), _T( "}5V" ),
										_T( "}10V" ), _T( "}20V" ), _T( "}50V" ), _T( "}100V" ) };
static LPCTSTR STR_ANALOG_RANGE_UNIT[] = { _T( "mV" ), _T( "mV" ), _T( "mV" ), _T( "V" ), _T( "V" ), _T( "V" ), _T( "V" ), _T( "V" ), _T( "V" ), _T( "V" ) };
static LPCTSTR STR_ANALOG_SMPMODE[] = { _T( "m[}" ), _T( "Ax[W" ) };
static const double VALUE_ANALOG_RANGE[] = { 100, 200, 500, 1, 2, 5, 10, 20, 50, 100 };
// Xe[^X
static LPCTSTR STR_LOG_STATUS[] = { _T( "MO~" ), _T( "MOs" ) };
static LPCTSTR STR_OVERRUN_ERROR[] = { _T( "G[Ȃ" ), _T( "n[hobt@G[" ), _T( "\tgobt@G[" ) };

//-------------------------------------------------------------------
// ֐vg^Cv
//-------------------------------------------------------------------
static double VoltValue( DWORD dwRange, DWORD dwData );
static void ResultMessage( LPCTSTR lpszBuf );
static void ErrorMessage( WORD wDeviceNo );
static LPCTSTR GetErrorStr( DWORD dwRes );

//===================================================================
// Main
//===================================================================
int WINAPI _tWinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow )
{
	TCHAR		szBuf[512];
	DWORD		i, j, num;

	WORD		wDeviceNo;
	DWORD		dwDrvVer, dwDllVer;
	TDEVINFO	DevInfo;
	TCHAR		szVid[PAS1000_VID_LENGTH];
	TCHAR		szPid[PAS1000_PID_LENGTH];
	DWORD		dwUnitId, dwNumCh, dwMaxNumCh;
	struct tm	dt;
	time_t		now;
	DWORD		dwHostTime[PAS1000_DATE_TIME_LENGTH];
	DWORD		dwFirmTime[PAS1000_DATE_TIME_LENGTH];
	DWORD		dwFpgaTime[PAS1000_DATE_TIME_LENGTH];
	DWORD		dwAdjStatus;
	TSETMODE	SetMode;
	TCHAR		szCh[32];
	DWORD		dwStartMode;
	DWORD		dwSmpTime;
	TCHAR		szSmpTime[8];
	DWORD		dwHardNumData, dwSoftNumData, dwLogStatus, dwOverrunError;
	PBYTE		bLogBuf;
	int			DispCh;
	BYTE		bTmStampBuf[8];
	DWORD64		dwTmStamp;
	BYTE		bEv, bCh;
	TCHAR		szTmStamp[32];
	TCHAR		szData[512];
	TCHAR		szTemp[16];
	BYTE		bInValue;

	// ϐ
	wDeviceNo = PAS1000_DEVICE_AUTO;
	dwDllVer = 0;
	dwDrvVer = 0;
	memset( &DevInfo, 0, sizeof( TDEVINFO ) );
	memset( &szVid, '\0', sizeof( szVid ) );
	memset( &szPid, '\0', sizeof( szPid ) );
	dwUnitId = 0;
	dwNumCh = 0;
	memset( &dwHostTime, 0, sizeof( dwHostTime ) );
	memset( &dwFirmTime, 0, sizeof( dwFirmTime ) );
	memset( &dwFpgaTime, 0, sizeof( dwFpgaTime ) );
	dwAdjStatus = 0;
	memset( &SetMode, 0, sizeof( TSETMODE ) );
	memset( &szCh, '\0', sizeof( szCh ) );
	dwStartMode = 0;
	memset( &szSmpTime, '\0', sizeof( szSmpTime ) );
	dwHardNumData = 0;
	dwSoftNumData = 0;
	dwLogStatus = 0;
	dwOverrunError = 0;
	DispCh = -1;
	memset( &bTmStampBuf, 0, sizeof( bTmStampBuf ) );
	memset( &szTmStamp, '\0', sizeof( szTmStamp ) );
	memset( &szData, '\0', sizeof( szData ) );
	memset( &szTemp, '\0', sizeof( szTemp ) );
	bInValue = 0;

	//---------------------------------------------------------------
	// DLL̎gp錾
	//---------------------------------------------------------------
	if ( FALSE == Pas1000wDllOpen() ) {
		ErrorMessage( wDeviceNo );
		goto END_PROCESS;
	}

	//---------------------------------------------------------------
	// foCX̏
	//---------------------------------------------------------------
	if ( FALSE == Pas1000wInitialize( 0, 0, -1 ) ) {
		ErrorMessage( wDeviceNo );
		goto END_PROCESS;
	}

	//---------------------------------------------------------------
	// foCX̌
	//---------------------------------------------------------------
	if ( FALSE == Pas1000wCreate( &wDeviceNo ) ) {
		ErrorMessage( wDeviceNo );
		goto END_PROCESS;
	}
	wsprintf( szBuf, _T( "foCX %d ̎gp錾܂B" ), wDeviceNo );
	ResultMessage( szBuf );

	//---------------------------------------------------------------
	// o[W擾
	//---------------------------------------------------------------
	if ( FALSE == Pas1000wGetVersion( &dwDrvVer, &dwDllVer ) ) {
		ErrorMessage( wDeviceNo );
		goto END_PROCESS;
	}
	wsprintf( szBuf, _T( "<< o[W >>\n" )
						_T( "    hCo : %.8lXH\n" )
						_T( "    DLL : %.8lXH" ),
						dwDrvVer,
						dwDllVer );
	ResultMessage( szBuf );

	//---------------------------------------------------------------
	// foCX擾
	//---------------------------------------------------------------
	if ( FALSE == Pas1000wGetDevInfo( wDeviceNo, &DevInfo ) ) {
		ErrorMessage( wDeviceNo );
		goto END_PROCESS;
	}
	for ( i = 0; i < PAS1000_VID_LENGTH; i++ ) {
		if ( ' ' == DevInfo.bVendorID[i] ) break;
		szVid[i] = DevInfo.bVendorID[i];
	}
	for ( i = 0; i < PAS1000_PID_LENGTH; i++ ) {
		if ( ' ' == DevInfo.bProductID[i] ) break;
		szPid[i] = DevInfo.bProductID[i];
	}
	wsprintf( szBuf, _T( "<< foCX >>\n" )
						_T( "    x_ ID : %s\n" )
						_T( "    v_Ng ID : %s\n" )
						_T( "    t@[o[W : %d.%.2d\n" )
						_T( "    FPGA o[W : %d.%.2d\n" )
						_T( "    USB ][h : %s" ),
						szVid,
						szPid,
						DevInfo.bFirmVer / 100, DevInfo.bFirmVer % 100,
						DevInfo.bFpgaVer / 100, DevInfo.bFpgaVer % 100,
						STR_USB_MODE[DevInfo.bUsbMode] );
	ResultMessage( szBuf );

	//---------------------------------------------------------------
	// jbg擾
	//---------------------------------------------------------------
	if ( FALSE == Pas1000wGetUnitInfo( wDeviceNo, &dwUnitId, &dwNumCh ) ) {
		ErrorMessage( wDeviceNo );
		goto END_PROCESS;
	}
	dwMaxNumCh = ( dwNumCh + 1 ) * 4;
	wsprintf( szBuf, _T( "<< jbg >>\n" )
						_T( "    jbg ID : %d\n" )
						_T( "    AiO`l : %dCH" ),
						dwUnitId,
						dwMaxNumCh );
	ResultMessage( szBuf );

	//---------------------------------------------------------------
	// ̐ݒ
	//---------------------------------------------------------------
	time( &now );										// ݂̎擾
	localtime_s( &dt, &now );
	dwHostTime[0] = dt.tm_year + 1900 - 2000;			// N(2)
	dwHostTime[1] = dt.tm_mon + 1;						// 
	dwHostTime[2] = dt.tm_mday;							// 
	dwHostTime[3] = dt.tm_wday;							// j
	dwHostTime[4] = dt.tm_hour;							// 
	dwHostTime[5] = dt.tm_min;							// 
	dwHostTime[6] = dt.tm_sec;							// b
	if ( FALSE == Pas1000wSetTime( wDeviceNo, &dwHostTime[0] ) ) {
		ErrorMessage( wDeviceNo );
		goto END_PROCESS;
	}

	//---------------------------------------------------------------
	// ̎擾
	//---------------------------------------------------------------
	if ( FALSE == Pas1000wGetTime( wDeviceNo, &dwFirmTime[0], &dwFpgaTime[0], &dwAdjStatus ) ) {
		ErrorMessage( wDeviceNo );
		goto END_PROCESS;
	}
	wsprintf( szBuf, _T( "<<  >> \n" )
						_T( "    t@[ : 20%.2d/%.2d/%.2d(%s) %.2d:%.2d:%.2d\n" )
						_T( "    FPGA : 20%.2d/%.2d/%.2d %.2d:%.2d:%.2d\n" ),
						dwFirmTime[0], dwFirmTime[1], dwFirmTime[2], STR_WEEK[dwFirmTime[3]],
						dwFirmTime[4], dwFirmTime[5], dwFirmTime[6],
						dwFpgaTime[0], dwFpgaTime[1], dwFpgaTime[2],
						dwFpgaTime[4], dwFpgaTime[5], dwFpgaTime[6] );
	ResultMessage( szBuf );

	//---------------------------------------------------------------
	// 샂[hݒ
	//---------------------------------------------------------------
	// AiO
	for ( i = 0; i < PAS1000_ANALOG_NUM_CH; i++ ) {
		if ( dwMaxNumCh <= i ) break;
		SetMode.Analog.Ch[i].dwChEnable = 1;			// `l:L
		SetMode.Analog.Ch[i].dwType = 0;				// ̓^Cv:d
		SetMode.Analog.Ch[i].dwRange = 6;				// ̓W:}10V
	}
	SetMode.Analog.StartTrig.dwEnable = 0;				// X^[ggK:
	SetMode.Analog.StopTrig.dwEnable = 0;				// XgbvgK:
	SetMode.Analog.dwSamplingMode = 1;					// TvO[h:Ax[W
	SetMode.Analog.dwSamplingTime = 1000;				// TvO^C:1ms
	SetMode.Analog.dwStartTimeEnable = 0;				// X^[g^C:
	SetMode.Analog.dwLoggingSize = 1000;				// MOTCY:1000(1b)
	// OgK
	for ( i = 0; i < PAS1000_EXTRIG_NUM_CH; i++ ) {
		SetMode.ExTrig[i].dwInSlope = 0;				// ̓X[v:
		SetMode.ExTrig[i].dwInFilter = 0;				// ̓tB^:0ms
	}
	// A[
	for ( i = 0; i < PAS1000_ANALOG_NUM_CH; i++ ) {
		if ( dwMaxNumCh <= i ) break;
		SetMode.Alarm.Analog[i].dwEnable = 0;			// AiOA[:
	}
	SetMode.Alarm.ExTrig.dwEnable = 0;					// OgKA[:
	// fW^o
	for ( i = 0; i < PAS1000_DIGITALOUT_NUM_CH; i++ ) {
		SetMode.DigitalOut[i].dwType = 0;				// o̓^Cv:fW^o͂̐ݒl𔽉f
	}
	if ( FALSE == Pas1000wSetMode( wDeviceNo, &SetMode ) ) {
		ErrorMessage( wDeviceNo );
		goto END_PROCESS;
	}
	for ( i = 0; i < PAS1000_ANALOG_NUM_CH; i++ ) {
		if ( 0 == SetMode.Analog.Ch[i].dwChEnable ) continue;
		if ( '\0' != szCh[0] ) {
			wsprintf( szCh, _T( "%s/" ), szCh );
		}
		wsprintf( szCh, _T( "%sCH%d" ), szCh, i + 1 );

		if ( -1 == DispCh ) {
			DispCh = i;									// ʕ\p`lݒ
		}
	}
	dwSmpTime = SetMode.Analog.dwSamplingTime;
	if ( 1000 > dwSmpTime ) {
		wsprintf( szSmpTime, _T( "s" ) );
	}
	else if ( 1000000 > dwSmpTime ) {
		dwSmpTime /= 1000;
		wsprintf( szSmpTime, _T( "ms" ) );
	}
	else {
		dwSmpTime /= ( 1000 * 1000 );
		wsprintf( szSmpTime, _T( "s" ) );
	}
	wsprintf( szBuf, _T( "<< 샂[h ( AiO ) >>\n" )
						_T( "    `l : %s\n" )
						_T( "    ̓^Cv : %s\n" )
						_T( "    ̓W : %s\n" )
						_T( "    X^[ggK : %s\n" )
						_T( "    XgbvgK : %s\n" )
						_T( "    TvO[h : %s\n" )
						_T( "    TvO^C : %d%s\n" )
						_T( "    X^[g^C : %s\n" )
						_T( "    MOTCY : %d" ),
						szCh,
						STR_ANALOG_TYPE[SetMode.Analog.Ch[DispCh].dwType],
						STR_ANALOG_RANGE[SetMode.Analog.Ch[DispCh].dwRange],
						STR_ENABLE[SetMode.Analog.StartTrig.dwEnable],
						STR_ENABLE[SetMode.Analog.StopTrig.dwEnable],
						STR_ANALOG_SMPMODE[SetMode.Analog.dwSamplingMode],
						dwSmpTime, szSmpTime,
						STR_ENABLE[SetMode.Analog.dwStartTimeEnable],
						SetMode.Analog.dwLoggingSize );
	ResultMessage( szBuf );

	//---------------------------------------------------------------
	// MO̊Jn
	//---------------------------------------------------------------
	for ( i = 0; i < PAS1000_ANALOG_NUM_CH; i++ ) {
		if ( dwMaxNumCh <= i ) break;
		if ( 1 == SetMode.Analog.Ch[i].dwChEnable ) {
			dwStartMode |= (DWORD)( 1 << i );
		}
	}
	memset( &szCh, '\0', sizeof( szCh ) );
	for ( i = 0; i < PAS1000_ANALOG_NUM_CH; i++ ) {
		if ( 0 == ( dwStartMode & ( 1 << i ) ) ) continue;
		if ( '\0' != szCh[0] ) {
			wsprintf( szCh, _T( "%s/" ), szCh );
		}
		wsprintf( szCh, _T( "%sCH%d" ), szCh, i + 1 );
	}
	wsprintf( szBuf, _T( "<< MOJn >>\n" )
						_T( "    AiO`l : %s\n\n" )
						_T( " MO͎Iɒ~܂B\n" )
						_T( "    << MO~ >> ƕ\܂ł҂B" ),
						szCh );
	ResultMessage( szBuf );
	if ( FALSE == Pas1000wStartLogging( wDeviceNo, dwStartMode ) ) {
		ErrorMessage( wDeviceNo );
		goto END_PROCESS;
	}
	Sleep( 1000 );										// 1b҂

	// MOI҂
	while ( 1 ) {
		//-----------------------------------------------------------
		// `lʂ̃Xe[^X擾
		//-----------------------------------------------------------
		if ( FALSE == Pas1000wGetStatus( wDeviceNo, &dwHardNumData, &dwSoftNumData, &dwLogStatus, &dwOverrunError ) ) {
			ErrorMessage( wDeviceNo );
			goto END_PROCESS;
		}
		// S`l̃MO~ŁAn[hobt@̃MOf[^ 0 ̏ꍇAMOI
		if ( ( PAS1000_STOP_LOGGING == dwLogStatus ) && ( 0 == dwHardNumData ) ) break;
	}

	//---------------------------------------------------------------
	// MO̒~
	//---------------------------------------------------------------
	if ( FALSE == Pas1000wStopLogging( wDeviceNo ) ) {
		ErrorMessage( wDeviceNo );
		goto END_PROCESS;
	}
	ResultMessage( _T( "<< MO~ >>" ) );

	//---------------------------------------------------------------
	// `lʂ̃Xe[^X擾
	//---------------------------------------------------------------
	if ( FALSE == Pas1000wGetStatus( wDeviceNo, &dwHardNumData, &dwSoftNumData, &dwLogStatus, &dwOverrunError ) ) {
		ErrorMessage( wDeviceNo );
		goto END_PROCESS;
	}
	wsprintf( szBuf, _T( "<< `lʂ̃Xe[^X >>\n" )
						_T( "    n[hobt@ : %d |Cg\n" )
						_T( "    \tgobt@ : %d |Cg\n" )
						_T( "    MOXe[^X : %s\n" )
						_T( "    I[o[G[ : %s\n" ),
						dwHardNumData,
						dwSoftNumData,
						STR_LOG_STATUS[dwLogStatus],
						STR_OVERRUN_ERROR[dwOverrunError] );
	ResultMessage( szBuf );

	//---------------------------------------------------------------
	// MOf[^擾
	//---------------------------------------------------------------
	bLogBuf = (PBYTE)malloc( dwSoftNumData * 3 );
	memset( bLogBuf, 0, dwSoftNumData * 3 );
	if ( FALSE == Pas1000wGetData( wDeviceNo, dwSoftNumData, bLogBuf ) ) {
		ErrorMessage( wDeviceNo );
		goto END_PROCESS;
	}
	for ( i = 0, j = 0, num = 1; i < ( dwSoftNumData * 3 ); i += 3 ) {
		bEv = (BYTE)( bLogBuf[i] & 0xE0 );				// Cxg
		bCh = (BYTE)( bLogBuf[i] & 0x0F );				// `l

		// \p`l̃f[^擾
		if ( DispCh == bCh ) {
			// ^CX^v
			if ( 0 != bEv ) {
				bTmStampBuf[j++] = bLogBuf[i + 1];
				bTmStampBuf[j++] = bLogBuf[i + 2];
			}
			// f[^
			else {
				_stprintf_s( szTemp, sizeof( szTemp ) / sizeof( TCHAR ), _T( "%.5f" ),
								VoltValue( SetMode.Analog.Ch[DispCh].dwRange,
												( (DWORD)bLogBuf[i + 1] << 8 ) | (DWORD)bLogBuf[i + 2] ) );
				wsprintf( szData, _T( "%s       %d : %.2X%.2XH ( %s )\n" ),
									szData, num, bLogBuf[i + 1], bLogBuf[i + 2], szTemp );
				if ( 10 == num ) break;				// 10\
				num++;
			}
		}
	}
	free( bLogBuf );
	dwTmStamp = ( (DWORD64)bTmStampBuf[0] << 56 )
					| ( (DWORD64)bTmStampBuf[1] << 48 )
					| ( (DWORD64)bTmStampBuf[2] << 40 )
					| ( (DWORD64)bTmStampBuf[3] << 32 )
					| ( (DWORD64)bTmStampBuf[4] << 24 )
					| ( (DWORD64)bTmStampBuf[5] << 16 )
					| ( (DWORD64)bTmStampBuf[6] << 8 )
					| (DWORD64)bTmStampBuf[7];
	wsprintf( szTmStamp, _T( "%.2d/%.2d/%.2d %.2d:%.2d:%.2d.%.6d" ),
							(BYTE)( ( dwTmStamp >> 46 ) & 0x7F ),
							(BYTE)( ( dwTmStamp >> 42 ) & 0x0F ),
							(BYTE)( ( dwTmStamp >> 37 ) & 0x1F ),
							(BYTE)( ( dwTmStamp >> 32 ) & 0x1F ),
							(BYTE)( ( dwTmStamp >> 26 ) & 0x3F ),
							(BYTE)( ( dwTmStamp >> 20 ) & 0x3F ),
							(DWORD)( dwTmStamp & 0xFFFFF ) );
	wsprintf( szBuf, _T( "<< MOf[^ >>\n" )
						_T( "    AiO`l : CH%d\n" )
						_T( "    ^CX^v : %s\n\n" )
						_T( "    f[^ [ %d |Cg ]\n%s\n" )
						_T( "    JbR͓dl ( P : %s )" ),
						DispCh + 1,
						szTmStamp,
						num,
						szData,
						STR_ANALOG_RANGE_UNIT[SetMode.Analog.Ch[DispCh].dwRange] );
	ResultMessage( szBuf );

	//---------------------------------------------------------------
	// fW^͂̓ǂݍ
	//---------------------------------------------------------------
	if ( FALSE == Pas1000wDigitalIn( wDeviceNo, &bInValue ) ) {
		ErrorMessage( wDeviceNo );
		goto END_PROCESS;
	}
	wsprintf ( szBuf, _T( "<< fW^ >>\n" )
						_T( "    ǂݍ݃f[^ : %.2XH" ),
						bInValue );
	ResultMessage( szBuf );

END_PROCESS:
	//---------------------------------------------------------------
	// foCX̊J
	//---------------------------------------------------------------
	if ( PAS1000_DEVICE_AUTO != wDeviceNo ) {
		if ( FALSE == Pas1000wClose( wDeviceNo ) ) {
			ErrorMessage( wDeviceNo );
		}
		wsprintf( szBuf, _T( "foCX %d J܂B"), wDeviceNo );
		ResultMessage( szBuf );
	}

	//---------------------------------------------------------------
	// foCX̏I
	//---------------------------------------------------------------
	Pas1000wTerminate();

	return 0;
}

//===================================================================
// MOf[^dlɊZ
//
// 		dwRange	̓W
//			dwData	MOf[^
// ߂l	dl
//===================================================================
static double VoltValue( DWORD dwRange, DWORD dwData )
{
	double	Vmax, Vmin;

	Vmax = VALUE_ANALOG_RANGE[dwRange];
	Vmin = -Vmax;
	return ( ( Vmax - Vmin ) * dwData / DATA_RESOLUTION + Vmin );
}

//===================================================================
// ʂ\
//
// 		strMsg	\郁bZ[W
//===================================================================
static void ResultMessage( LPCTSTR lpszBuf )
{
	MessageBox( NULL, lpszBuf, szTitle, MB_OK | MB_ICONINFORMATION );
}

//===================================================================
// G[bZ[W\
//
// 		wDeviceNo	G[擾foCXʔԍ
//===================================================================
static void ErrorMessage( WORD wDeviceNo )
{
	DWORD	dwRes;
	TCHAR	szBuf[128];

	dwRes = Pas1000wGetLastError( wDeviceNo );
	wsprintf( szBuf, _T( "%s" ), GetErrorStr( dwRes ) );
	MessageBox( NULL, szBuf, szTitle, MB_OK | MB_ICONSTOP );
}

//===================================================================
// G[擾
//
// 		dwRes	G[ԍ
// ߂l	G[
//===================================================================
static LPCTSTR GetErrorStr( DWORD dwRes )
{
	TCHAR	szBuf[128];

	switch ( dwRes & 0xFFFF )
	{
		case PAS1000_ERR_SYSTEM:
			return _T( "VXeG[łB" );
		case PAS1000_ERR_NO_DEVICE:
			return _T( "gp\ȃfoCX܂B" );
		case PAS1000_ERR_IN_USE:
			return _T( "w̃foCX͎gpłB" );
		case PAS1000_ERR_INVALID_DEVICENO:
			return _T( "sȃfoCXʔԍłB" );
		case PAS1000_ERR_INVALID_ARGUMENT:
			wsprintf( szBuf, _T( "sȈw肳܂B" ) );
			if ( 0 != ( dwRes >> 16 ) ) {
				wsprintf( szBuf, _T( "%s\n[ Error code : %.4XH ]" ), szBuf, dwRes >> 16 );
			}
			return &szBuf[0];
		case PAS1000_ERR_INTERNAL:
			return _T( "G[łB" );
		case PAS1000_ERR_TRANSFER_TIMEOUT:
			return _T( "f[^]^CAEgɂȂ܂B" );
		case PAS1000_ERR_TRANSFER_CANCEL:
			return _T( "f[^]LZ܂B" );
		case PAS1000_ERR_TRANSFER_FAIL:
			return _T( "f[^]s܂B" );
		case PAS1000_ERR_TRANSFER_SIZE:
			return _T( "f[^]̃TCYsłB" );
		case PAS1000_ERR_HARDBUFF_OVERRUN:
			return _T( "n[hobt@I[o[܂B" );
		case PAS1000_ERR_SOFTBUFF_OVERRUN:
			return _T( "\tgobt@I[o[܂B" );
		case PAS1000_ERR_DEVICE:
			wsprintf( szBuf, _T( "foCXG[łB" ) );
			if ( 0 != ( dwRes >> 16 ) ) {
				wsprintf( szBuf, _T( "%s\n[ Error code : %.4XH ]" ), szBuf, dwRes >> 16 );
			}
			return &szBuf[0];
		case PAS1000_ERR_WRAPDLL:
			return _T( "DLL ̃[hɎs܂B" );
		default:
			wsprintf( szBuf, _T( "`̃G[łB\n[ Error code : %.8XH ]" ), dwRes );
			return &szBuf[0];
	}
}
